@echo off
::   COPYRIGHT:         OCO SOURCE MATERIALS
::                      (C) Copyright IBM Corp. 2001
::                      All rights reserved.
::                      US Government Users Restricted Rights - Use,
::                      duplication or disclosure restricted by
::                      GSA ADP Schedule Contract with IBM
::                      Corporation.  See IBM Copyright Instructions
::                      IBM CONFIDENTIAL
::                      (IBM CONFIDENTIAL-RESTRICTED when aggregated)
::
:: Module Name:
::
::    sddgetdata.bat
::
:: Abstract:
::   
::    This is a Windows Utility for IBM(R) System Storage Multipath 
::    Subsystem Device Driver DSM(SDDDSM). This will facilitate the
::    trace collection functionality for SDDDSM
::
:: Environment:
::
::    Windows 2000 and Above
::

setlocal

ECHO Collecting SDD trace Data
ECHO.

:::: We need to create a unique directory using HostName, Date and Time. 
:::: We need to pasre the date and time to remove the unwanted characters like " ./" to make the directory name Windows Compatible.
FOR /F "tokens=1-4 delims=/.: " %%M IN ("%date%") DO set Cdate=%%P%%N%%O
::echo %Cdate%
FOR /F "tokens=1-3 delims=/.: " %%J IN ("%time%") DO set Ctime=%%J%%K%%L
::echo %Ctime%

:: Now we have all the data to construct the directory name.
set datetime=%Cdate%_%Ctime%
set dirname=sdddata_%ComputerName%_%datetime%

:::: 1st we need to move to the dir where SDDDSM is installed then come back to original dir
pushd "%ProgramFiles%\IBM\SDDDSM\"

md %dirname%

ECHO ***************************************************************************** > dir_list_%datetime%.txt
ECHO ***** List of all files under SDD directory and its sub-directories      **** >> dir_list_%datetime%.txt
ECHO ***************************************************************************** >> dir_list_%datetime%.txt
dir /s |findstr /v "%datetime%" >> dir_list_%datetime%.txt
ECHO. >> dir_list_%datetime%.txt
ECHO. >> dir_list_%datetime%.txt
ECHO. >> dir_list_%datetime%.txt
ECHO ***************************************************************************** >> dir_list_%datetime%.txt
ECHO ***** List of SDD and HBA Driver Files in drivers directory              **** >> dir_list_%datetime%.txt
ECHO ***************************************************************************** >> dir_list_%datetime%.txt
dir %windir%\system32\drivers\ | findstr /i "sdd mp storport ntfs ql elx" >> dir_list_%datetime%.txt
ECHO. >> dir_list_%datetime%.txt
ECHO. >> dir_list_%datetime%.txt
ECHO. >> dir_list_%datetime%.txt
ECHO ***************************************************************************** >> dir_list_%datetime%.txt
ECHO ***** SDD version from SDD readme file                                   **** >> dir_list_%datetime%.txt
ECHO ***************************************************************************** >> dir_list_%datetime%.txt
findstr /i  "version" readme.txt>> dir_list_%datetime%.txt
ECHO. >> dir_list_%datetime%.txt
ECHO. >> dir_list_%datetime%.txt
ECHO. >> dir_list_%datetime%.txt

move dir_list_%datetime%.txt %dirname% > NUL


ECHO Collecting datapath command outputs
ECHO.

ECHO ************************************************* > dpq_%datetime%.txt
ECHO ***** Output of datapath query adapter       **** >> dpq_%datetime%.txt
ECHO ************************************************* >> dpq_%datetime%.txt
datapath query adapter >> dpq_%datetime%.txt
ECHO. >> dpq_%datetime%.txt
ECHO. >> dpq_%datetime%.txt
ECHO. >> dpq_%datetime%.txt
ECHO ************************************************* >> dpq_%datetime%.txt
ECHO ***** Output of datapath query device -l     **** >> dpq_%datetime%.txt
ECHO ************************************************* >> dpq_%datetime%.txt
datapath query device -l >> dpq_%datetime%.txt
ECHO. >> dpq_%datetime%.txt
ECHO. >> dpq_%datetime%.txt
ECHO. >> dpq_%datetime%.txt
ECHO ************************************************* >> dpq_%datetime%.txt
ECHO ***** Output of datapath query device -s     **** >> dpq_%datetime%.txt
ECHO ************************************************* >> dpq_%datetime%.txt
datapath query device -s >> dpq_%datetime%.txt
ECHO. >> dpq_%datetime%.txt
ECHO. >> dpq_%datetime%.txt
ECHO. >> dpq_%datetime%.txt
ECHO ************************************************* >> dpq_%datetime%.txt
ECHO ***** Output of datapath query wwpn          **** >> dpq_%datetime%.txt
ECHO ************************************************* >> dpq_%datetime%.txt
datapath query wwpn >> dpq_%datetime%.txt
ECHO. >> dpq_%datetime%.txt
ECHO. >> dpq_%datetime%.txt
ECHO. >> dpq_%datetime%.txt
ECHO ************************************************* >> dpq_%datetime%.txt
ECHO ***** Output of datapath query version  **** >> dpq_%datetime%.txt
ECHO ************************************************* >> dpq_%datetime%.txt
datapath query version >> dpq_%datetime%.txt
ECHO. >> dpq_%datetime%.txt
ECHO. >> dpq_%datetime%.txt
ECHO. >> dpq_%datetime%.txt
ECHO ************************************************* >> hba_%datetime%.txt
ECHO ***** HBA Detail                             **** >> hba_%datetime%.txt
ECHO ************************************************* >> hba_%datetime%.txt
gethba detail >> hba_%datetime%.txt
ECHO. >> hba_%datetime%.txt
ECHO. >> hba_%datetime%.txt
ECHO. >> hba_%datetime%.txt


move dpq_%datetime%.txt %dirname% > NUL
move hba_%datetime%.txt %dirname% > NUL


ECHO Collecting SDD and SDDSrv logs
ECHO.

copy %windir%\system32\sdd.log %dirname% > NUL
copy %windir%\system32\sdd_bak.log %dirname% > NUL
copy %windir%\system32\sddsrv.log %dirname% > NUL
copy %windir%\system32\sddsrv_bak.log %dirname% > NUL

ECHO Collecting Most current driver trace
ECHO.

set traceFilePresent=no
if EXIST trace.out set traceFilePresent=yes
if %traceFilepresent%==yes ren trace.out trace.out.old

ECHO 777 >pathtest_input.txt
ECHO. >>pathtest_input.txt
ECHO 20 >>pathtest_input.txt
ECHO 2 >>pathtest_input.txt
ECHO. >>pathtest_input.txt
ECHO 88 >>pathtest_input.txt
ECHO 22 >>pathtest_input.txt
ECHO 99 >>pathtest_input.txt
ECHO. >>pathtest_input.txt
ECHO 99 >>pathtest_input.txt
ECHO. >>pathtest_input.txt
ECHO. >>pathtest_input.txt

type pathtest_input.txt | pathtest -d \\.\sddpath > NUL

del pathtest_input.txt
move trace.out %dirname%\sdd_pathtest_trace.log > NUL
if %traceFilepresent%==yes ren trace.out.old trace.out

if EXIST %windir%\cluster\cluster.log ECHO Collecting Cluster Log
if EXIST %windir%\cluster\cluster.log copy %windir%\cluster\cluster.log %dirname% > NUL
if EXIST %windir%\cluster\cluster.log ECHO.

regedit /e sdd_temp_ccs_reg.txt HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\
if EXIST sdd_temp_ccs_reg.txt move sdd_temp_ccs_reg.txt %dirname%\%ComputerName%_CurrentControlSet_Key.txt > NUL

regedit /e sdd_temp_DeviceMap_reg.txt HKEY_LOCAL_MACHINE\HARDWARE\DEVICEMAP\
if EXIST sdd_temp_DeviceMap_reg.txt move sdd_temp_DeviceMap_reg.txt %dirname%\%ComputerName%_DeviceMap_Key.txt > NUL

regedit /e sdd_temp_cluster_reg.txt HKEY_LOCAL_MACHINE\Cluster\
if EXIST sdd_temp_cluster_reg.txt move sdd_temp_cluster_reg.txt %dirname%\%ComputerName%_CLUSTER_Key.txt > NUL

:: Time to collect Eventlog
sddutils getsystemlog > NUL
move system.evt %dirname%\System_%ComputerName%_%datetime%.evt > NUL

ECHO Generating a CAB file for all the Logs

:: generate the cab file
cd %dirname%

ECHO .OPTION EXPLICIT  > sdd_temp_cab.txt
ECHO .Set CabinetNameTemplate=SDDCab.cab >> sdd_temp_cab.txt
ECHO .Set CompressionType=MSZIP >> sdd_temp_cab.txt
ECHO .Set UniqueFiles="OFF" >> sdd_temp_cab.txt
ECHO .Set Cabinet=on >> sdd_temp_cab.txt
ECHO .Set DiskDirectory1=SDDCAB >> sdd_temp_cab.txt
dir /b |findstr /v /i "sdd_temp_cab.txt">> sdd_temp_cab.txt 

makecab.exe /f sdd_temp_cab.txt > NUL

move SDDCAB\SDDCAB.cab ..\ > NUL
cd ..

rd %dirname% /s /q
move SDDCAB.cab %dirname%.cab > NUL

ECHO.
ECHO %dirname%.cab file generated

popd
endlocal
